
#include "QtWidgetsApplication4.h"
#include<iostream>

#include<opencv2/imgproc.hpp>
#include<opencv2/imgcodecs.hpp>
#include<opencv2/highgui.hpp>
#include<opencv2/tracking.hpp>
#include<windows.h>
#include<mmsyscom.h>
#pragma comment(lib,"winmm.lib")
using namespace std;
using namespace cv;
Mat firstFrame;
Point previousPoint, currentPoint;
Rect bbox;
int flag = 0;
DWORD WINAPI PlayMusic(LPVOID lpParameter)//һµĽ 
{
    while (1) {
        //ļ 
        mciSendString(TEXT("open  C:\\Users\\asus\\source\\repos\\opencvprojrct\\opencvprojrct\\resources\\Ƶ.MP3 alias s1"), NULL, 1, NULL);
        // 
        mciSendString(TEXT("play s1"), NULL, 0, NULL);
        // 
        Sleep(9000 * 8);
        //ر 
        mciSendString(TEXT("close S1"), NULL, 0, NULL);
    }
    return 0;
}

QtWidgetsApplication4::QtWidgetsApplication4(QWidget* parent)
    : QMainWindow(parent)
{
    ui.setupUi(this);

    connect(ui.pushButton_2, &QPushButton::clicked, this,
        &QtWidgetsApplication4::onOpencvpic);

    connect(ui.pushButton, &QPushButton::clicked, this,
        &QtWidgetsApplication4::videoplay);
    cas.load("C:\\Users\\asus\\source\\repos\\opencvprojrct\\opencvprojrct\\resources\\haarcascade_frontalface_default.xml");

    ui.progressBar_2->setValue(v);
    ui.progressBar_2->setVisible(0);
   
}


QtWidgetsApplication4::~QtWidgetsApplication4()
{}


void QtWidgetsApplication4::resizeEvent(QResizeEvent* event)
{
    img_show = img_src.scaled(ui.label->size(), Qt::KeepAspectRatio, Qt::SmoothTransformation);
    img_pix = QPixmap::fromImage(img_show);
    ui.label->setPixmap(img_pix);
}

void draw_rectangle(int event, int x, int y, int flags, void*)
{
    if (event == EVENT_LBUTTONDOWN)
    {
        previousPoint = Point(x, y);
    }
    if (event == EVENT_MOUSEMOVE && (flags & EVENT_FLAG_LBUTTON))
    {
        Mat tmp;
        firstFrame.copyTo(tmp);
        currentPoint = Point(x, y);
        rectangle(tmp, previousPoint, currentPoint, Scalar(0, 255, 0, 0), 1, 8, 0);
        imshow("output", tmp);
    }
    if (event == EVENT_LBUTTONUP)
    {
        bbox.x = previousPoint.x;
        bbox.y = previousPoint.y;
        bbox.width = abs(previousPoint.x - currentPoint.x);
        bbox.height = abs(previousPoint.y - currentPoint.y);

        destroyWindow("output");
    }

}


void QtWidgetsApplication4::videoplay()
{
   if (flag == 0) {
        HANDLE hThread = CreateThread(NULL, 0, PlayMusic, NULL, 0, NULL);
        flag = 1;
    }
    
    ui.progressBar_2->setVisible(1);
    Mat frame;
    VideoCapture capture;
    frame = capture.open("C:\\Users\\asus\\source\\repos\\opencvprojrct\\opencvprojrct\\resources\\video3.mp4");

    if (!capture.isOpened())
    {
        printf("can not open ...\n");
    }
    //ȡƵĵһ֡,ѡĿ
    capture.read(firstFrame);
    if (!firstFrame.empty())
    {
        waitKey(30);
        imshow("output", firstFrame);
        setMouseCallback("output", draw_rectangle, 0);
        waitKey();


    }
    //ʹTracker
    Ptr<TrackerCSRT> tracker = TrackerCSRT::create();

    capture.read(frame);
    tracker->init(frame, bbox);
    //namedWindow("output", WINDOW_AUTOSIZE);
    while (capture.read(frame))
    {
        bool t = tracker->update(frame, bbox);
        if (t) rectangle(frame, bbox, Scalar(255, 0, 0), 2, 1);

        img_src = QImage(frame.data, frame.cols, frame.rows, frame.step, QImage::Format_BGR888);
        img_show = img_src.scaled(ui.label->size(), Qt::KeepAspectRatio, Qt::FastTransformation);
        img_pix = QPixmap::fromImage(img_show);
        ui.label->setPixmap(img_pix);
        if (waitKey(1) == 'q') break;
        v += 1;
        ui.progressBar_2->setValue(v);
    }
    capture.release();
    destroyAllWindows();
}

void QtWidgetsApplication4::onOpencvpic()
{
    if (flag == 0) {
        HANDLE hThread = CreateThread(NULL, 0, PlayMusic, NULL, 0, NULL);
        flag = 1;
    }
    ui.progressBar_2->setVisible(0);
    // Ƶļ
    VideoCapture capture("C:\\Users\\asus\\source\\repos\\opencvprojrct\\opencvprojrct\\resources\\bike.avi");
    // ǰƵ֡
    Mat frame;
    // ǰĶֵͼ
    Mat foreground;
    // ͼ
    Mat background;

    // ϸ˹ģĶȫĬϲ
    Ptr<BackgroundSubtractorMOG2> ptrMOG = createBackgroundSubtractorMOG2(500, 16, false);

    bool stop = false;
    // Ƶе֡
    while (!stop) {
        // ȡһ֡У
        if (!capture.read(frame))
            break;
        Mat result = frame.clone();
        // ±ǰ
        ptrMOG->apply(frame, foreground, 0.03);
        // ĽͼЧ
        threshold(foreground, foreground, 25,
            255, THRESH_BINARY);
        //4.ʴ
        Mat kernel_erode = getStructuringElement(MORPH_RECT, Size(5, 5));
        Mat kernel_dilate = getStructuringElement(MORPH_RECT, Size(11, 11));
        erode(foreground, foreground, kernel_erode);
        //imshow("erode", diff_thresh);
        //5.
        dilate(foreground, foreground, kernel_dilate);
        //medianBlur(foreground, foreground,11);//ֵ˲ȥ
         //6.
        vector<vector<Point> > contours;
        findContours(foreground, contours, RETR_EXTERNAL, CHAIN_APPROX_SIMPLE);
        for (int i = 0; i < contours.size(); i++)
        {
            vector<Point> hull;
            convexHull(contours[i], hull);

            // ͹
            double area = contourArea(hull);
            // һֵɸѡȤ
            if (area > 500 && area < 1000) { // ֵʵ
                rectangle(result, boundingRect(contours[i]), Scalar(0, 255, 0), 1);//resultϻӾ
            }
        }

        //imshow("result", result);
        //ʹLabelʾͼƬ
        img_src = QImage(result.data, result.cols, result.rows, result.step, QImage::Format_BGR888);
        img_show = img_src.scaled(ui.label->size(), Qt::KeepAspectRatio, Qt::FastTransformation);
        img_pix = QPixmap::fromImage(img_show);
        ui.label->setPixmap(img_pix);
        // ʱ߰
        if (waitKey(10) >= 0)
            stop = true;
  
   
    }

}
