#pragma once

#include <QtWidgets/QMainWindow>
#include "ui_QtWidgetsApplication4.h"
#include<opencv2/opencv.hpp>

class QtWidgetsApplication4 : public QMainWindow
{
    Q_OBJECT

public:
    QtWidgetsApplication4(QWidget *parent = nullptr);
    ~QtWidgetsApplication4();
    virtual void resizeEvent(QResizeEvent* event);
   
public slots:
    void onOpencvpic();
    void videoplay();

private:
    Ui::QtWidgetsApplication4Class ui;
    QImage img_src;
    QImage img_show;
    QPixmap img_pix;
    cv::CascadeClassifier cas;
    int v = 0;
    
};
